//Include file for 8KHz to 11025Hz.  Greatest Common Denominator (GCD) = 320/441.

#define HALFB 0						// Half band flag
#define NUPST 1						// Number of up stages
#define PVTFL 1						// Pivot flag
#define NDWNS 0						// Number of down stages
#define STAGE 2						// Number of total stages 
#define NINPS 320					// Number of input samples (Should be a even multiple of the GCD 
#define NOUTS 441					// Number of output samples (Should be be the same multiple as above of the GCD

#define INTP1 3
#define DOWN1 1
#define LENG1 319					// LENG1 = length of stage filter
#define PLEN1 107					// PLEN1 = MLEN1/INTP1 (polyphase length)
#define MLEN1 321					// MLEN1 = LENG1 + enough to make even length for polyphase
#define SHFT1 0
#define NINP1 NINPS					// NINPS (...or NOUTS)
#define SZIN1 (NINP1 + ((LENG1-1)/INTP1) + 1) // 


#define INTP2 147
#define DOWN2 320
#define LENG2 579					// LENG2 = length of stage filter
#define PLEN2 4						// PLEN2 = MLEN2/INTP2 (polyphase length)
#define MLEN2 588					// MLEN2 = LENG2 + enough to make even length for polyphase
#define SHFT2 0
#define NINP2 ((NINP1*INTP1)/DOWN1)	// (NINPx*INTPx)/DOWNx 
#define SZIN2 (NINP2 + ((LENG2-1)/INTP2) + 1) // 

#define NINP3 ((NINP2*INTP2)/DOWN2)	// (NINPx*INTPx)/DOWNx 
#define SZIN3 NINP3 + 1  			// for last decimation stage only 


#define OFFS1 (LENG1-1)/(2*DOWN1)	//
#define OFFS2 (LENG2-1)/(2*DOWN2)	// 


#if OFFS2 < 1
#define OF2S2 1
#else
#define OF2S2 OFFS2
#endif

#define TOFS1 OFFS1							// 
#define TOFS2 ((INTP2*TOFS1)/DOWN2 + OFFS2)	// 

//#define T2FS3 57

//#define DOFS2 (NOUTS-TOFS2-1)		// Offset used to strip filter delays (zeros) off buffers

#define DOFS2 NOUTS	
